###############################
# +---------------------------
# |
# | D e n i z e n   P l a y e r   M o d e l s
# |
# | Animated players in Java Minecraft!
# |
# +---------------------------
##Player Models
# @Contributors Max^, mcmonkey
# @Special thanks to mcmonkey for creating dmodels and making this possible for everyone!
# @date 2022/06/03
# @updated 2022/06/10
# @denizen-build REL-1772
# @script-version 1.1 BETA
# @Github https://github.com/FutureMaximus/Denizen-Player-Models
##Note: This will not work Denizen release version 1771 or below.
##Update 1.1 Info:
#- Added ability to use external bones

##NOTICE: This will not work on minecraft versions below 1.17 and will not work with any other
##rendertype_entity_translucent core shader files it must be the one provided by mccosmetics or here.
##Tested Minecraft Version: 1.18.2
##Description:

# Denizen Player Models allows you to take the texture of any player or npc and animate them with a model of the player!
# For more control over the player models there is an API as well.
# I plan on adding more features such as mobility tasks in the future.

#####################
##Info:

#Uses elements from dmodels by mcmonkey https://github.com/mcmonkeyprojects/DenizenModels and requires the bbmodel converter by dmodels for the animations.

#For player emotes made by other people https://mcmodels.net/?product_cat=&post_type=product&s=Emote (Must be for the mccosmetics plugin not IA).

#Denizen Player Models allows the use of player model animations useful for emotes or cutscenes as a per player showing task is available.

#Compatible with the mccosmetics plugin

##How to get started:

##Notice: If you have the mccosmetics core shader file and player_animator folder you can skip this part
#Put the core shader files provided in your resource pack minecraft folder "minecraft/shaders/core/rendertype_entity_translucent.vsh"
#, "minecraft/shaders/core/rendertype_entity_translucent.fsh" and "minecraft/shaders/core/rendertype_entity_translucent.json"

#Put the player_animator folder inside your resource pack assets "resource_pack/assets/player_animator"

#Put the player_head.json model item file in your minecraft resource pack folder "minecraft/models/item/player_head.json"

##########################

#Put the player model template files in "Denizen/player_models/templates/player_model_template_norm.yml" and "Denizen/player_models/templates/player_model_template_slim.yml"

##Notice: You need DenizenModelsConverter for this to work which can be found at https://github.com/mcmonkeyprojects/DenizenModels
#To use your animations you need to generate a dmodel file with your animated player bbmodel file or the bbmodel template provided and get the dmodel file generated by the DenizenModelsConverter
#afterwards put the file in "Denizen/player_models/animations/my_animation.dmodel.yml"

#Example usage in cmd (You may need to run cmd as administrator):
#cd C:/Program Files/DenizenModelsConverter
#DenizenModelsConverter.exe make_pack my_animations.bbmodel resource_pack player_animations/sword_swing_animation player_animations/sword_swing_animation --item:iron_ingot
#(use it on an item you don't use to avoid conflict with your resource pack)

##External Bone Usage (Version 1.1):
#Things to know:
# - External bones must be in a single bbmodel file
# - You can have multiple animations using the same external bone(s)
# - You can attach external bones to the player model's bones such as the right forearm if you want to
#How to use:
#Generate a dmodel file for the animation and put the custom items (external bones) in your resource pack made from
#the DenizenModelsConverter (Make sure to do it on an item you don't use to avoid conflict with your resource pack) with --item:(material)
#Put the dmodel file in your animations folder
#Once you've zipped your resource pack you can do /pmodel reload and enjoy
#How to import java items into your player model bbmodel file:
#In your player model bbmodel file go to file/import/"import project" then select your java item bbmodel file

#####################
##Config:
pmodel_config:
  type: data
  config:
    #load animations on server start this should generally be kept true
    load_on_start: true
    #reload scripts on player model reload (Should only be true when debugging)
    reload_scripts: true

#command for ops only (here you can reload the animations)
#/pmodel reload or /denizenplayermodels reload
pmodel_base_command:
  type: command
  debug: false
  name: denizenplayermodels
  usage: /denizenplayermodels
  aliases:
  - pmodel
  description: Pmodel command
  permission: op.op
  script:
  - if <context.args.get[1]> == reload && <player.is_op> || <context.source_type> == SERVER:
    - if <script[pmodel_config].data_key[config].get[reload_scripts].equals[true]>:
      - reload
    - ~run pmodels_load_animation def:classic
    - ~run pmodels_load_animation def:slim
    - narrate "[Denizen Player Models] Reloaded animations."

#############################
##API Usage
# # To spawn the player model
# - run pmodels_spawn_model def.location:<player.location> def.player:<player[FutureMaximus]> save:spawned
# - define root <entry[spawned].created_queue.determination.first>
# # To spawn the player model that only shows for one player (useful for cutscenes)
# - run pmodels_spawn_model def.location:<player.location> def.player:<player[FutureMaximus]> def.show_to:<player[FutureMaximus]> save:spawned
# - define root <entry[spawned].created_queue.determination.first>
# # To move the whole player model
# - teleport <[root]> <player.location>
# - run pmodels_reset_model_position def.root_entity:<[root]>
# # To start an automatic animation
# - run pmodels_animate def.root_entity:<[root]> def.animation:idle
# # To end an automatic animation
# - run pmodels_end_animation def.root_entity:<[root]>
# # To move the player model to a single frame of an animation (timespot is a decimal number of seconds from the start of the animation)
# - run pmodels_move_to_frame def.root_entity:<[root]> def.animation:idle def.timespot:0.5
# # To remove the player model
# - run pmodels_remove_model def.root_entity:<[root]>
# # To remove external parts of player model
# - run pmodels_remove_external_parts def.root_entity:<[root]>
###############################
# TODO:
# - No longer be dependent on DenizenModelsConverter and generate animations or external bones in a script including excluding player model parts
# - Create utility tasks players can use for the player models such as the third person camera or moving
# - Add support for hand/offhand items with the ability to turn this off for certain animations
# - Add animation to animation transitions and ability to transition to default state 0,0,0
